Name:           netdisco 
Version:        1.1 
Release:        1%{?dist}
Summary:        A web-based network management tool 
License:        BSD
Group:          Applications/Internet 
URL:            http://netdisco.org/ 
Source0:        http://downloads.sourceforge.net/project/%{name}/%{name}/%{version}/%{name}-%{version}_with_mibs.tar.gz
Source1:        netdisco.init
Source2:        netdisco_config
Source3:        INSTALL.fedora
Source4:        INSTALL.rhel
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
Requires:       httpd
Requires:       postgresql postgresql-server
Requires:       net-snmp net-snmp-perl
Requires:       mod_perl mod_ssl
Requires:       graphviz graphviz-gd wget 
Requires:       perl(DBI) 
Requires:       perl(Apache::DBI)
Requires:       perl(DBD::Pg)
Requires:       perl(Apache::Session)
Requires:       perl(HTML::Parser)  
Requires:       perl(HTML::Mason)
Requires:       perl(MasonX::Request::WithApacheSession)
Requires:       perl(Graph) 
Requires:       perl(GraphViz)
Requires:       perl(Compress::Zlib) 
Requires:       perl(Net::NBName) 
Requires:       perl-libapreq2 
Requires:       perl(SNMP::Info) 
Requires:       perl(Parallel::ForkManager) 
Requires:       perl(Net::LDAP) 
Requires:       perl(Net::SSLeay) 
Requires:       perl(IO::Socket::SSL) 
Requires(pre):  /usr/sbin/useradd

%description
Netdisco is a network management application targeted at large
corporate and university networks. Data is collected into a Postgres
database using SNMP and presented with a clean web interface using Mason.

Designed for moderate to large networks, configuration information
and connection data for network devices are retrieved by SNMP.
With Netdisco you can locate the switch port of an end-user system
by IP or MAC address. Data is stored using a SQL database for scalability
and speed. Layer-2 topology protocols such as CDP (Cisco Discovery Protocol)
optionally provides automatic discovery of the network topology.


%prep
%setup -q -n %{name}-%{version} 
/usr/bin/iconv -f iso8859-1 -t utf-8 ChangeLog > ChangeLog.conv && /bin/mv -f ChangeLog.conv ChangeLog
%define debug_package %{nil}

cp %{SOURCE1} netdisco.init
cp %{SOURCE2} netdisco_config
cp %{SOURCE3} INSTALL.fedora 
cp %{SOURCE4} INSTALL.rhel 

# remove malformed-line-in-lsb-comment-block in netdisco.init - from netdisco source
perl -pi -e "s|# corporate and university networks.||g" netdisco.init

# prefix fix
find -type f | xargs perl -pi -e "s|/usr/local/netdisco|/usr/share/netdisco|g"
# perl path fix 
find -type f | xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g"
# shebang fix
find -type f | xargs perl -pi -e "s|#/bin/sh|#!/bin/sh|g"

# config file path fix
perl -pi -e "s|\"\\\$Dir/netdisco\.conf\"\;|\'%{_sysconfdir}/netdisco\.conf\'\;|" sql/pg


%build


# make some man pages too :)
pod2man netdisco > netdisco.1
pod2man netdisco.pm > netdisco.pm.1

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/httpd/conf.d
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_mandir}/man1
install -d %{buildroot}%_datadir/%{name}/switch
install -d %{buildroot}%_datadir/%{name}/data/logs
install -d %{buildroot}/var/run/netdisco
install -d %{buildroot}%perl_vendorlib

install -m0644 netdisco.conf %{buildroot}%{_sysconfdir}/
install -m0644 netdisco_apache.conf %{buildroot}%{_sysconfdir}/httpd/conf.d/
install -m0644 netdisco_apache_dir.conf %{buildroot}%{_sysconfdir}/httpd/conf.d/
install -m0755 netdisco %{buildroot}%{_sbindir}/

install -m0644 netdisco.1 %{buildroot}%{_mandir}/man1/
install -m0644 netdisco.pm.1 %{buildroot}%{_mandir}/man1/

install -m0755 netdisco.init %{buildroot}%{_initrddir}/netdisco
install -m0755 netdisco_config %{buildroot}%{_sbindir}/netdisco_config
install -m0644 netdisco.pm %{buildroot}/%perl_vendorlib/ 

%__cp -aRf * %{buildroot}%_datadir/%{name}/
#%__mv %{buildroot}%_datadir/%{name}/%{name}-mibs-%{mibs_version} %{buildroot}%_datadir/%{name}/mibs/
%__rm -rf %{buildroot}%_datadir/%{name}/netdisco.conf
%__ln_s %{_sysconfdir}/netdisco.conf %{buildroot}%_datadir/%{name}/netdisco.conf

%__chmod 0644 %{buildroot}%_datadir/%{name}/mibs/cisco/CISCO-VSAN-MIB.my
%__chmod 0644 %{buildroot}%_datadir/%{name}/mibs/cisco/CISCO-LWAPP-DOT11-CCX-CLIENT-DIAG-MIB.my
%__chmod 0644 %{buildroot}%_datadir/%{name}/mibs/hp/hpicfvrrp.mib
%__chmod 0644 %{buildroot}%_datadir/%{name}/mibs/hp/hpicfratelimit.mib
%__chmod 0644 %{buildroot}%_datadir/%{name}/mibs/hp/hpicfipaddress.mib
%__chmod 0644 %{buildroot}%_datadir/%{name}/mibs/hp/hpicfpim.mib
%__chmod -R 0755 %{buildroot}%_datadir/%{name}/bin/install/0.94/
%__chmod -R 0755 %{buildroot}%_datadir/%{name}/bin/install/0.95/
%__chmod -R 0755 %{buildroot}%_datadir/%{name}/bin/install/1.0/
%__chmod -R 0644 %{buildroot}%_datadir/%{name}/bin/install/0.94/readme*


%pre
%__mkdir %_datadir/%{name}
/usr/sbin/useradd %{name} -d %_datadir/%{name}/ -s /bin/sh  1>&2 > /dev/null
# apache needs to read /etc/netdisco.conf, but it contains a plain
# text password to the postgresql netdisco database, so the file
# requires stricter file permissions...
/usr/bin/gpasswd -a apache netdisco 1>&2 > /dev/null


%post
   /sbin/chkconfig --add %{name}
   echo ''
   echo ''
   echo '**************************************************************************************************'
   echo '**************************************************************************************************'
   echo ''
   echo 'To configure netdisco for your environment, you need to run the /usr/sbin/netdisco_config script.'
   echo ''
   echo '**************************************************************************************************'
   echo '**************************************************************************************************'
   echo ''
   echo ''



%preun
if [ "$1" = "0" ]; then
   /sbin/service %{name} stop > /dev/null 2>&1
   /sbin/chkconfig --del %{name}
fi


%postun
%__rm -rf %_datadir/%{name}


%clean
%__rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc ChangeLog INSTALL README* UPGRADE INSTALL.fedora INSTALL.rhel
%{_initrddir}/netdisco
%config(noreplace) %{_sysconfdir}/netdisco.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/netdisco_apache.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/netdisco_apache_dir.conf
%{_sbindir}/netdisco
%{_sbindir}/netdisco_config
%ghost /var/run/netdisco
%perl_vendorlib/netdisco.pm
%dir %_datadir/netdisco
%_datadir/netdisco/*
%{_mandir}/man1/*

 

%changelog
* Thu Oct 13 2011 <gouldwp@fedoraproject.org> 1.1-1
- Netdisco network management software.
- Changed %dir/var/run/netdisco to %ghost /var/run/netdisco - bug 656636 
- Upstream 1.1 release
* Tue Nov 9 2009 <gouldwp@fedoraproject.org> 1.0-2
- Upstream 1.0 release
- Added require graphviz-gd package for graphing to work 
- Added chkconfig line in netdisco_config script
- Changed chkconfig line in netdisco.init script to not start daemon by default
- Changed %%post section to work correctly with chkconfig
- Changed %%defattr(-,root,root) to %%defattr(-,root,root,-) in files section
- Changed /usr/share/ to %%_datadir in the %%files section
- Removed patches, substituted with find/perl/xargs replace lines 
- Removed explicit %%attr lines in %%files

